<div align="center">
    <h2 align="center">
        <img src="https://forge.kworld.fr/foss/nabu/-/raw/master/nabu_logo.png" width="120"/>
<br>Nabû: <small>.NET data manipulation</small>
    </h2>
    <p align="center">
     <a href="https://dotnet.microsoft.com/">
        <img src="https://img.shields.io/badge/⩾-6.0-512BD4.svg?stylee&logo=dotnet" alt=".Net" />
        </a>     
<a href="https://dotnet.microsoft.com/en-us/languages/csharp">
    <img src="https://img.shields.io/badge/C%23-05930c.svg?stylee&logo=csharp" alt="C#" />
</a>

 <a href="https://forge.kworld.fr/foss/nabu/-/blob/master/LICENSE.txt">
    <img src="https://img.shields.io/badge/License-Apache%202.0-blue.svg" alt="apache2-license" />
    </a>    

<a href="https://forge.kworld.fr/foss/nabu/-/pipelines/latest?ref=master">
  <img src="https://img.shields.io/gitlab/pipeline-status/foss%2Fnabu?gitlab_url=https%3A%2F%2Fforge.kworld.fr%2F&branch=master&logo=gitlab" alt="CI Status" />
</a>    
</p>
<hr>
</div>


Nabû is an open-source suite of libraries designed to manipulate structured data in .NET development through streamlined interactions.  
It's divided into Two components:

- **Nabu.Data**: Provides data manipulation abstraction, encompassing CRUD operations and sophisticated querying using LinQ.
- **Nabu.Storage**: Provides standardized file manipulation abstractions, catering to local, remote, and cloud-based files.

#### Latest packages

<a href="https://nuget.kworld.dev/packages/nabu.data">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.data%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Data&color=green" alt="Data Nuget" />
</a>
<a href="https://nuget.kworld.dev/packages/nabu.data.entityframework">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.data.entityframework%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Data.EntityFramework&color=darkgreen" alt="Data.EntityFramework Nuget" />
</a>
<a href="https://nuget.kworld.dev/packages/nabu.entityframework.blazor">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.data.entityframework.blazor%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Data.EntityFramework.Blazor&color=darkgreen" alt="Data.EntityFramework.Blazor Nuget" />
</a>
<a href="https://nuget.kworld.dev/packages/nabu.data.litedb">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.data.litedb%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Data.LiteDb&color=purple" alt="Data.LiteDb Nuget" />
</a>

<br>
<a href="https://nuget.kworld.dev/packages/nabu.storage">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.storage%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Storage&color=blue" alt="Storage Nuget" />
</a>
<a href="https://nuget.kworld.dev/packages/nabu.storage.local">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.storage.local%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Storage.Local&color=darkblue" alt="Storage.Local Nuget" />
</a>
<a href="https://nuget.kworld.dev/packages/nabu.storage.minio">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.storage.minio%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Storage.Minio&color=cyan" alt="Storage.Minio Nuget" />
</a>
<a href="https://nuget.kworld.dev/packages/nabu.storage.litedb">
 <img src="https://img.shields.io/badge/dynamic/json?url=https%3A%2F%2Fnuget.kworld.dev%2Fv3%2Fregistration%2Fnabu.storage.litedb%2Findex.json&query=%24.items%5B0%5D.upper&logo=nuget&label=Nabu.Storage.LiteDb&color=purple" alt="Storage.LiteDb Nuget" />
</a>

---

## Installation

Before installing Nabû, make sure to add the custom NuGet source to your configuration.  
Open a terminal or command prompt and run the following command:

```bash
dotnet nuget add source "https://nuget.kworld.dev/v3/index.json" -n "kworld NuGet"
```

Now you can install the various components of Nabû with the following commands:

```bash

# Nabu.Data
dotnet add package my_awesome_project.csproj Nabu.Core 
dotnet add package my_awesome_project.csproj Nabu.Data.EntityFramework # For EntityFramework implementation
dotnet add package my_awesome_project.csprojNabu.Data.LiteDb # For LiteDB implementation

# Nabu.Storage
dotnet add package my_awesome_project.csproj Nabu.Storage
dotnet add package my_awesome_project.csproj Nabu.Storage.Local # For local storage
dotnet add package my_awesome_project.csproj Nabu.Storage.Minio # For Minio (Amazon S3) storage
```

## Getting started

### IDao: Data manipulation Interface

Nabu.Data provide the IDao interface in order to standardize data CRUD.

#### Usage

//TODO

## Documentation

For comprehensive insights into the capabilities and nuances of Nabû, refer to the official documentation:

[Documentation Link]()

## Contributing

Join us in enhancing Nabû! We welcome contributions in the form of suggestions, bug reports, and pull requests. Check out the [Contribution Guidelines](https://forge.kworld.fr/foss/nabu/-/blob/master/CONTRIBUTING.md) to get involved.

## License

This project operates under the Apache 2.0 License. For more details, refer to the [LICENSE](https://forge.kworld.fr/foss/nabu/-/blob/master/LICENSE.txt) file.

## Why "Nabû" ?

__Nabû__ (Akkadian: cuneiform: 𒀭𒀝) is the name of and old Mesopotamian God.  
In ancient cultures, __Nabû__ was revered as a deity associated with wisdom, scholarship, and the recording of informations. __Nabû__'s symbols included a stylus resting on a tablet.

By adopting those name and symbols, this suite of libraries refers, in a cool way, to the the art of writing and recording of informations.
